import type { Optimization } from '@roots/bud-framework/config';
import { Bud } from '@roots/bud-framework';
export type Parameters = [
    (((splitChunks: false | Optimization.SplitChunks | undefined) => false | Optimization.SplitChunks) | boolean | Bud | Optimization.SplitChunks)?
];
export interface splitChunks {
    (...parameters: Parameters): Promise<Bud>;
}
/**
 * Bundle vendor modules separately from application code.
 *
 * @example
 * Enable chunk splitting
 *
 * ```js
 * bud.splitChunks()
 * ```
 *
 * @example
 * Disable chunk splitting
 *
 * ```js
 * bud.splitChunks(false)
 * ```
 *
 * @example
 * Merge optimization.splitChunks object
 *
 * ```js
 * bud.splitChunks({chunks: 'all'})
 * ```
 */
export declare const splitChunks: splitChunks;
